DIM InFile$
'----------------------------------------------------------------------------
' CONSTANT                    MEANING
'----------------------------------------------------------------------------
'FILE_ATTRIBUTE_ARCHIVE   -- The file is an archive file
'FILE_ATTRIBUTE_HIDDEN    -- The file is hidden
'FILE_ATTRIBUTE_NORMAL    -- The file has no other attributes set
'FILE_ATTRIBUTE_OFFLINE   -- The data of the file is not immediately available
'FILE_ATTRIBUTE_READONLY  -- The file is read-only
'FILE_ATTRIBUTE_SYSTEM    -- The file is part of the operating system
'FILE_ATTRIBUTE_TEMPORARY -- The file is being used for temporary storage
'----------------------------------------------------------------------------
InFile$ = COMMAND$(1)

SetFileAttr(InFile$, FILE_ATTRIBUTE_HIDDEN )

SUB SetFileAttr(Filename$, FileAttribute%)
  SetFileAttributes(Filename$, FileAttribute%)
END SUB
